`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Engineer: Henriette M. Borgund
// 
// Create Date: 22.04.2018 22:24:22
// Design Name: Approximate Unconstrained Shift OR Sigma 
// Module Name: led_counter
// Project Name: SPAM filter
// Target Devices: Nexys4 DDR
// Tool Versions: Vivado 2017.4
// Description: This program takes a pattern and a text as input stored in RAM before programming the 
//  FPGA board. It will find hits of the pattern given and count the number of hit. LED lights will show the count
//  of hits. 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
module led_counter(clk,LED, SW, counter, R0, R1, R2, R3);
input clk;
input SW;
output reg [15:0] LED;
output reg [5:0] R0, R1, R2, R3;
reg [7:0] epost;
output reg [3:0] counter;
reg [5:0] D_a,D_b, D_c, D_d, D_e, D_f, D_g, D_h, D_i, D_j, D_k, D_l, D_m, D_n, D_o, D_p, D_q, D_r, D_s, D_t, D_u, D_v, D_w, D_x, D_y, D_z;
reg [5:0] V;
reg [5:0] R0temp[459:0], R1temp[459:0], R2temp[459:0],R3temp[459:0];
reg [7:0] rom[459:0];
integer i,ii, count;
integer y = 0;
reg [7:0]  pattern[6:0];


initial
   begin
        pattern[0] = 8'h76; //v
        pattern[1] = 8'h69; //i 
        pattern[2] = 8'h61; //a 
        pattern[3] = 8'h67; //g
        pattern[4] = 8'h72; //r
        pattern[5] = 8'h61; //a
   end
       
 always @ (posedge clk)  
 begin                   
      if ( pattern[y] == 8'h61 )
          begin
          D_a[y] = 0;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end 
             
       else if ( pattern[y] == 8'h62 )
          begin
            D_a[y] = 1;
            D_b[y] = 0;
            D_c[y] = 1;
            D_d[y] = 1;
            D_e[y] = 1;
            D_f[y] = 1;
            D_g[y] = 1;
            D_h[y] = 1;
            D_i[y] = 1;
            D_j[y] = 1;
            D_k[y] = 1;
            D_l[y] = 1;
            D_m[y] = 1;
            D_n[y] = 1;
            D_o[y] = 1;
            D_p[y] = 1;
            D_q[y] = 1;
            D_r[y] = 1;
            D_s[y] = 1;
            D_t[y] = 1;
            D_u[y] = 1;
            D_v[y] = 1;
            D_w[y] = 1;
            D_x[y] = 1;
            D_y[y] = 1;
            D_z[y] = 1;
           end 
                  
       else if ( pattern[y] == 8'h63 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 0;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;               
          end      
                 
       else if ( pattern[y] == 8'h64 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 0;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end 
                   
       else if ( pattern[y] == 8'h65 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 0;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end      
                     
       else if ( pattern[y] == 8'h66 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 0;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end 
                
       else if ( pattern[y] == 8'h67 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 0;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end      
                      
       else if ( pattern[y] == 8'h68 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 0;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end 
                 
       else if ( pattern[y] == 8'h69 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 0;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end 
   else if ( pattern[y] == 8'h6a )
         begin
         D_a[y] = 1;
         D_b[y] = 1;
         D_c[y] = 1;
         D_d[y] = 1;
         D_e[y] = 1;
         D_f[y] = 1;
         D_g[y] = 1;
         D_h[y] = 1;
         D_i[y] = 1;
         D_j[y] = 0;
         D_k[y] = 1;
         D_l[y] = 1;
         D_m[y] = 1;
         D_n[y] = 1;
         D_o[y] = 1;
         D_p[y] = 1;
         D_q[y] = 1;
         D_r[y] = 1;
         D_s[y] = 1;
         D_t[y] = 1;
         D_u[y] = 1;
         D_v[y] = 1;
         D_w[y] = 1;
         D_x[y] = 1;
         D_y[y] = 1;
         D_z[y] = 1;
         end 
            
      else if ( pattern[y] == 8'h6b )
         begin
         D_a[y] = 1;
         D_b[y] = 1;
         D_c[y] = 1;
         D_d[y] = 1;
         D_e[y] = 1;
         D_f[y] = 1;
         D_g[y] = 1;
         D_h[y] = 1;
         D_i[y] = 1;
         D_j[y] = 1;
         D_k[y] = 0;
         D_l[y] = 1;
         D_m[y] = 1;
         D_n[y] = 1;
         D_o[y] = 1;
         D_p[y] = 1;
         D_q[y] = 1;
         D_r[y] = 1;
         D_s[y] = 1;
         D_t[y] = 1;
         D_u[y] = 1;
         D_v[y] = 1;
         D_w[y] = 1;
         D_x[y] = 1;
         D_y[y] = 1;
         D_z[y] = 1;
         end 
                
      else if ( pattern[y] == 8'h6c )
         begin
         D_a[y] = 1;
         D_b[y] = 1;
         D_c[y] = 1;
         D_d[y] = 1;
         D_e[y] = 1;
         D_f[y] = 1;
         D_g[y] = 1;
         D_h[y] = 1;
         D_i[y] = 1;
         D_j[y] = 1;
         D_k[y] = 1;
         D_l[y] = 0;
         D_m[y] = 1;
         D_n[y] = 1;
         D_o[y] = 1;
         D_p[y] = 1;
         D_q[y] = 1;
         D_r[y] = 1;
         D_s[y] = 1;
         D_t[y] = 1;
         D_u[y] = 1;
         D_v[y] = 1;
         D_w[y] = 1;
         D_x[y] = 1;
         D_y[y] = 1;
         D_z[y] = 1;
         end      
 
      else if ( pattern[y] == 8'h6d )
         begin
         D_a[y] = 1;
         D_b[y] = 1;
         D_c[y] = 1;
         D_d[y] = 1;
         D_e[y] = 1;
         D_f[y] = 1;
         D_g[y] = 1;
         D_h[y] = 1;
         D_i[y] = 1;
         D_j[y] = 1;
         D_k[y] = 1;
         D_l[y] = 1;
         D_m[y] = 0;
         D_n[y] = 1;
         D_o[y] = 1;
         D_p[y] = 1;
         D_q[y] = 1;
         D_r[y] = 1;
         D_s[y] = 1;
         D_t[y] = 1;
         D_u[y] = 1;
         D_v[y] = 1;
         D_w[y] = 1;
         D_x[y] = 1;
         D_y[y] = 1;
         D_z[y] = 1;
         end    
                   
      else if ( pattern[y] == 8'h6e )
         begin
         D_a[y] = 1;
         D_b[y] = 1;
         D_c[y] = 1;
         D_d[y] = 1;
         D_e[y] = 1;
         D_f[y] = 1;
         D_g[y] = 1;
         D_h[y] = 1;
         D_i[y] = 1;
         D_j[y] = 1;
         D_k[y] = 1;
         D_l[y] = 1;
         D_m[y] = 1;
         D_n[y] = 0;
         D_o[y] = 1;
         D_p[y] = 1;
         D_q[y] = 1;
         D_r[y] = 1;
         D_s[y] = 1;
         D_t[y] = 1;
         D_u[y] = 1;
         D_v[y] = 1;
         D_w[y] = 1;
         D_x[y] = 1;
         D_y[y] = 1;
         D_z[y] = 1;
         end      
   
          
    else if ( pattern[y] == 8'h6f )
         begin
         D_a[y] = 1;
         D_b[y] = 1;
         D_c[y] = 1;
         D_d[y] = 1;
         D_e[y] = 1;
         D_f[y] = 1;
         D_g[y] = 1;
         D_h[y] = 1;
         D_i[y] = 1;
         D_j[y] = 1;
         D_k[y] = 1;
         D_l[y] = 1;
         D_m[y] = 1;
         D_n[y] = 1;
         D_o[y] = 0;
         D_p[y] = 1;
         D_q[y] = 1;
         D_r[y] = 1;
         D_s[y] = 1;
         D_t[y] = 1;
         D_u[y] = 1;
         D_v[y] = 1;
         D_w[y] = 1;
         D_x[y] = 1;
         D_y[y] = 1;
         D_z[y] = 1;
         end          
                 
       else if ( pattern[y] == 8'h70 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 0;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end 

             
       else if ( pattern[y] == 8'h71 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 0;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end 
                
       else if ( pattern[y] == 8'h72 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 0;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end      

             
       else if ( pattern[y] == 8'h73 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 0;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end 
             
       else if ( pattern[y] == 8'h74 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 0;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end 
                 
       else if ( pattern[y] == 8'h75 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 0;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end      
  
       else if ( pattern[y] == 8'h76 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 0;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end    
                    
       else if ( pattern[y] == 8'h77 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 0;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 1;
          end      
    
           
     else if ( pattern[y] == 8'h78 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 0;
          D_y[y] = 1;
          D_z[y] = 1;
          end 
           
     else if ( pattern[y] == 8'h79 )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 0;
          D_z[y] = 1;
          end 
               
     else if ( pattern[y] == 8'h7a )
          begin
          D_a[y] = 1;
          D_b[y] = 1;
          D_c[y] = 1;
          D_d[y] = 1;
          D_e[y] = 1;
          D_f[y] = 1;
          D_g[y] = 1;
          D_h[y] = 1;
          D_i[y] = 1;
          D_j[y] = 1;
          D_k[y] = 1;
          D_l[y] = 1;
          D_m[y] = 1;
          D_n[y] = 1;
          D_o[y] = 1;
          D_p[y] = 1;
          D_q[y] = 1;
          D_r[y] = 1;
          D_s[y] = 1;
          D_t[y] = 1;
          D_u[y] = 1;
          D_v[y] = 1;
          D_w[y] = 1;
          D_x[y] = 1;
          D_y[y] = 1;
          D_z[y] = 0;
          end      
                
    y = y + 1;                      
 end
  

    initial
       begin
        rom[0] = 8'h0;
        rom[1] = 8'h76;    //v
        rom[2] = 8'h69;    //i
        rom[3] = 8'h61;    //a
        rom[4] = 8'h67;    //g
        rom[5] = 8'h72;    //r
        rom[6] = 8'h61;    //a
        rom[7] = 8'h79;    
        rom[8] = 8'h66;   
        rom[9] = 8'h72;   
        rom[10] = 8'h69;    
        rom[11] = 8'h65;    
        rom[12] = 8'h6e;    
        rom[13] = 8'h64;    
        rom[14] = 8'h63;    
        rom[15] = 8'h61;    
        rom[16] = 8'h6e;   
        rom[17] = 8'h77;    
        rom[18] = 8'h65;    
        rom[19] = 8'h6d;    
        rom[20] = 8'h65;    
        rom[21] = 8'h61;    
        rom[22] = 8'h74;    
        rom[23] = 8'h66;    
        rom[24] = 8'h6f;    
        rom[25] = 8'h72;    
        rom[26] = 8'h61;    
        rom[27] = 8'h64;    
        rom[28] = 8'h69;   
        rom[29] = 8'h6e;    
        rom[30] = 8'h6e;    
        rom[31] = 8'h65;    
        rom[32] = 8'h72;    
        rom[33] = 8'h74;    
        rom[34] = 8'h68;    
        rom[35] = 8'h69;    
        rom[36] = 8'h73;    
        rom[37] = 8'h77;    
        rom[38] = 8'h65;    
        rom[39] = 8'h64;    
        rom[40] = 8'h6e;    
        rom[41] = 8'h65;    
        rom[42] = 8'h73;    
        rom[43] = 8'h64;    
        rom[44] = 8'h61;    
        rom[45] = 8'h79;    
        rom[46] = 8'h73;    
        rom[47] = 8'h63;    
        rom[48] = 8'h68;    
        rom[49] = 8'h6f;    
        rom[50] = 8'h6f;    
        rom[51] = 8'h6c;    
        rom[52] = 8'h69;    
        rom[53] = 8'h73;    
        rom[54] = 8'h76;    
        rom[55] = 8'h65;
        rom[56] = 8'h72;
        rom[57] = 8'h79;
        rom[58] = 8'h62;
        rom[59] = 8'h6f;
        rom[60] = 8'h72;
        rom[61] = 8'h69;
        rom[62] = 8'h6e;
        rom[63] = 8'h67;
        rom[64] = 8'h6c;
        rom[65] = 8'h61;
        rom[66] = 8'h74;
        rom[67] = 8'h65;
        rom[68] = 8'h6c;
        rom[69] = 8'h79;
        rom[70] = 8'h61;
        rom[71] = 8'h6e;
        rom[72] = 8'h64;
        rom[73] = 8'h69;
        rom[74] = 8'h6e;
        rom[75] = 8'h65;
        rom[76] = 8'h65;
        rom[77] = 8'h64;
        rom[78] = 8'h74;
        rom[79] = 8'h6f;
        rom[80] = 8'h62;
        rom[81] = 8'h65;
        rom[82] = 8'h63;
        rom[83] = 8'h68;
        rom[84] = 8'h65;
        rom[85] = 8'h65;
        rom[86] = 8'h72;
        rom[87] = 8'h65;
        rom[88] = 8'h64;
        rom[89] = 8'h75;
        rom[90] = 8'h70;
        rom[91] = 8'h77;
        rom[92] = 8'h69;
        rom[93] = 8'h6c;
        rom[94] = 8'h6c;
        rom[95] = 8'h79;
        rom[96] = 8'h6f;
        rom[97] = 8'h75;
        rom[98] = 8'h68;
        rom[99] = 8'h65;
        rom[100] = 8'h6c;
        rom[101] = 8'h70;
        rom[102] = 8'h6d;
        rom[103] = 8'h65;
        rom[104] = 8'h62;
        rom[105] = 8'h75;
        rom[106] = 8'h79;
        rom[107] = 8'h63;
        rom[108] = 8'h68;
        rom[109] = 8'h65;
        rom[110] = 8'h61;
        rom[111] = 8'h70;
        rom[112] = 8'h76;
        rom[113] = 8'h69;
        rom[114] = 8'h61;
        rom[115] = 8'h67;
        rom[116] = 8'h72;
        rom[117] = 8'h61;
        rom[118] = 8'h66;
        rom[119] = 8'h72;
        rom[120] = 8'h6f;
        rom[121] = 8'h6d;
        rom[122] = 8'h6f;
        rom[123] = 8'h75;
        rom[124] = 8'h72;
        rom[125] = 8'h63;
        rom[126] = 8'h6f;
        rom[127] = 8'h6d;
        rom[128] = 8'h70;
        rom[129] = 8'h61;
        rom[130] = 8'h6e;
        rom[131] = 8'h79;
        rom[132] = 8'h74;
        rom[133] = 8'h68;
        rom[134] = 8'h61;
        rom[135] = 8'h74;
        rom[136] = 8'h73;
        rom[137] = 8'h70;
        rom[138] = 8'h65;
        rom[139] = 8'h63;
        rom[140] = 8'h75;
        rom[141] = 8'h61;
        rom[142] = 8'h6c;
        rom[143] = 8'h69;
        rom[144] = 8'h7a;
        rom[145] = 8'h65;
        rom[146] = 8'h73;
        rom[147] = 8'h69;
        rom[148] = 8'h6e;
        rom[149] = 8'h74;
        rom[150] = 8'h68;
        rom[151] = 8'h65;
        rom[152] = 8'h73;
        rom[153] = 8'h65;
        rom[154] = 8'h70;
        rom[155] = 8'h69;
        rom[156] = 8'h6c;
        rom[157] = 8'h6c;
        rom[158] = 8'h73;
        rom[159] = 8'h74;
        rom[160] = 8'h68;
        rom[161] = 8'h65;
        rom[162] = 8'h79;
        rom[163] = 8'h61;
        rom[164] = 8'h72;
        rom[165] = 8'h65;
        rom[166] = 8'h73;
        rom[167] = 8'h6f;
        rom[168] = 8'h67;
        rom[169] = 8'h6f;
        rom[170] = 8'h6f;
        rom[171] = 8'h64;
        rom[172] = 8'h79;
        rom[173] = 8'h6f;
        rom[174] = 8'h75;
        rom[175] = 8'h63;
        rom[176] = 8'h61;
        rom[177] = 8'h6e;
        rom[178] = 8'h74;
        rom[179] = 8'h62;
        rom[180] = 8'h65;
        rom[181] = 8'h6c;
        rom[182] = 8'h69;
        rom[183] = 8'h65;
        rom[184] = 8'h76;
        rom[185] = 8'h65;
        rom[186] = 8'h69;
        rom[187] = 8'h74;
        rom[188] = 8'h79;
        rom[189] = 8'h65;
        rom[190] = 8'h73;
        rom[191] = 8'h69;
        rom[192] = 8'h77;
        rom[193] = 8'h6f;
        rom[194] = 8'h75;
        rom[195] = 8'h6c;
        rom[196] = 8'h64;
        rom[197] = 8'h6c;
        rom[198] = 8'h6f;
        rom[199] = 8'h76;
        rom[200] = 8'h74;
        rom[201] = 8'h6f;
        rom[202] = 8'h67;
        rom[203] = 8'h6f;
        rom[204] = 8'h74;
        rom[205] = 8'h6f;
        rom[206] = 8'h74;
        rom[207] = 8'h68;
        rom[208] = 8'h65;
        rom[209] = 8'h6d;
        rom[210] = 8'h6f;
        rom[211] = 8'h76;
        rom[212] = 8'h69;
        rom[213] = 8'h65;
        rom[214] = 8'h73;
        rom[215] = 8'h77;
        rom[216] = 8'h69;
        rom[217] = 8'h74;
        rom[218] = 8'h68;
        rom[219] = 8'h79;
        rom[220] = 8'h6f;
        rom[221] = 8'h75;
        rom[222] = 8'h77;
        rom[223] = 8'h68;
        rom[224] = 8'h61;
        rom[225] = 8'h74;
        rom[226] = 8'h6d;
        rom[227] = 8'h6f;
        rom[228] = 8'h76;
        rom[229] = 8'h69;
        rom[230] = 8'h65;
        rom[231] = 8'h64;
        rom[232] = 8'h6f;
        rom[233] = 8'h79;
        rom[234] = 8'h6f;
        rom[235] = 8'h75;
        rom[236] = 8'h77;
        rom[237] = 8'h61;
        rom[238] = 8'h6e;
        rom[239] = 8'h74;
        rom[240] = 8'h74;
        rom[241] = 8'h6f;
        rom[242] = 8'h73;
        rom[243] = 8'h65;
        rom[244] = 8'h65;
        rom[245] = 8'h74;
        rom[246] = 8'h68;
        rom[247] = 8'h65;
        rom[248] = 8'h72;
        rom[249] = 8'h65;
        rom[250] = 8'h69;
        rom[251] = 8'h73;
        rom[252] = 8'h61;
        rom[253] = 8'h6e;
        rom[254] = 8'h65;
        rom[255] = 8'h77;
        rom[256] = 8'h6d;
        rom[257] = 8'h6f;
        rom[258] = 8'h76;
        rom[259] = 8'h69;
        rom[260] = 8'h65;
        rom[261] = 8'h67;
        rom[262] = 8'h6f;
        rom[263] = 8'h69;
        rom[264] = 8'h6e;
        rom[265] = 8'h67;
        rom[266] = 8'h74;
        rom[267] = 8'h68;
        rom[268] = 8'h65;
        rom[269] = 8'h73;
        rom[270] = 8'h65;
        rom[271] = 8'h64;
        rom[272] = 8'h61;
        rom[273] = 8'h79;
        rom[274] = 8'h73;
        rom[275] = 8'h74;
        rom[276] = 8'h68;
        rom[277] = 8'h61;
        rom[278] = 8'h74;
        rom[279] = 8'h69;
        rom[280] = 8'h68;
        rom[281] = 8'h61;
        rom[282] = 8'h76;
        rom[283] = 8'h65;
        rom[284] = 8'h6e;
        rom[285] = 8'h74;
        rom[286] = 8'h73;
        rom[287] = 8'h65;
        rom[288] = 8'h65;
        rom[289] = 8'h6e;
        rom[290] = 8'h62;
        rom[291] = 8'h75;
        rom[292] = 8'h74;
        rom[293] = 8'h74;
        rom[294] = 8'h68;
        rom[295] = 8'h61;
        rom[296] = 8'h74;
        rom[297] = 8'h69;
        rom[298] = 8'h68;
        rom[299] = 8'h61;
        rom[300] = 8'h76;
        rom[301] = 8'h65;
        rom[302] = 8'h62;
        rom[303] = 8'h65;
        rom[304] = 8'h65;
        rom[305] = 8'h6e;
        rom[306] = 8'h77;
        rom[307] = 8'h61;
        rom[308] = 8'h6e;
        rom[309] = 8'h74;
        rom[310] = 8'h69;
        rom[311] = 8'h6e;
        rom[312] = 8'h67;
        rom[313] = 8'h74;
        rom[314] = 8'h6f;
        rom[315] = 8'h73;
        rom[316] = 8'h65;
        rom[317] = 8'h65;
        rom[318] = 8'h77;
        rom[319] = 8'h6f;
        rom[320] = 8'h75;
        rom[321] = 8'h6c;
        rom[322] = 8'h64;
        rom[323] = 8'h79;
        rom[324] = 8'h6f;
        rom[325] = 8'h75;
        rom[326] = 8'h6c;
        rom[327] = 8'h69;
        rom[328] = 8'h6b;
        rom[329] = 8'h65;
        rom[330] = 8'h74;
        rom[331] = 8'h6f;
        rom[332] = 8'h73;
        rom[333] = 8'h65;
        rom[334] = 8'h65;
        rom[335] = 8'h69;
        rom[336] = 8'h74;
        rom[337] = 8'h77;
        rom[338] = 8'h69;
        rom[339] = 8'h74;
        rom[340] = 8'h68;
        rom[341] = 8'h6d;
        rom[342] = 8'h65;
        rom[343] = 8'h62;
        rom[344] = 8'h75;
        rom[345] = 8'h79;
        rom[346] = 8'h6f;
        rom[347] = 8'h75;
        rom[348] = 8'h72;
        rom[349] = 8'h76;
        rom[350] = 8'h65;
        rom[351] = 8'h72;
        rom[352] = 8'h79;
        rom[353] = 8'h67;
        rom[354] = 8'h6f;
        rom[355] = 8'h6f;
        rom[356] = 8'h64;
        rom[357] = 8'h76;
        rom[358] = 8'h6c;
        rom[359] = 8'h61;
        rom[360] = 8'h67;
        rom[361] = 8'h72;
        rom[362] = 8'h61;
        rom[363] = 8'h70;
        rom[364] = 8'h69;
        rom[365] = 8'h6c;
        rom[366] = 8'h6c;
        rom[367] = 8'h73;
        rom[368] = 8'h74;
        rom[369] = 8'h68;
        rom[370] = 8'h61;
        rom[371] = 8'h74;
        rom[372] = 8'h61;
        rom[373] = 8'h72;
        rom[374] = 8'h65;
        rom[375] = 8'h73;
        rom[376] = 8'h6f;
        rom[377] = 8'h67;
        rom[378] = 8'h6f;
        rom[379] = 8'h6f;
        rom[380] = 8'h64;
        rom[381] = 8'h79;
        rom[382] = 8'h6f;
        rom[383] = 8'h75;
        rom[384] = 8'h77;
        rom[385] = 8'h69;
        rom[386] = 8'h6c;
        rom[387] = 8'h6c;
        rom[388] = 8'h6e;
        rom[389] = 8'h65;
        rom[390] = 8'h76;
        rom[391] = 8'h65;
        rom[392] = 8'h72;
        rom[393] = 8'h74;
        rom[394] = 8'h72;
        rom[395] = 8'h79;
        rom[396] = 8'h61;
        rom[397] = 8'h6e;
        rom[398] = 8'h79;
        rom[399] = 8'h74;
        rom[400] = 8'h68;
        rom[401] = 8'h69;
        rom[402] = 8'h6e;
        rom[403] = 8'h67;
        rom[404] = 8'h65;
        rom[405] = 8'h6c;
        rom[406] = 8'h73;
        rom[407] = 8'h65;
        rom[408] = 8'h61;
        rom[409] = 8'h6e;
        rom[410] = 8'h64;
        rom[411] = 8'h79;
        rom[412] = 8'h6f;
        rom[413] = 8'h75;
        rom[414] = 8'h77;
        rom[415] = 8'h69;
        rom[416] = 8'h6c;
        rom[417] = 8'h6c;
        rom[418] = 8'h6e;
        rom[419] = 8'h65;
        rom[420] = 8'h76;
        rom[421] = 8'h65;
        rom[422] = 8'h72;
        rom[423] = 8'h73;
        rom[424] = 8'h65;
        rom[425] = 8'h65;
        rom[426] = 8'h61;
        rom[427] = 8'h6e;
        rom[428] = 8'h6f;
        rom[429] = 8'h66;
        rom[430] = 8'h66;
        rom[431] = 8'h65;
        rom[432] = 8'h72;
        rom[433] = 8'h6c;
        rom[434] = 8'h69;
        rom[435] = 8'h6b;
        rom[436] = 8'h65;
        rom[437] = 8'h74;
        rom[438] = 8'h68;
        rom[439] = 8'h69;
        rom[440] = 8'h73;
        rom[441] = 8'h61;
        rom[442] = 8'h67;
        rom[443] = 8'h61;
        rom[444] = 8'h69;
        rom[445] = 8'h6e;
        rom[446] = 8'h69;
        rom[447] = 8'h73;
        rom[448] = 8'h6e;
        rom[449] = 8'h74;
        rom[450] = 8'h74;
        rom[451] = 8'h68;
        rom[452] = 8'h61;
        rom[453] = 8'h74;
        rom[454] = 8'h72;
        rom[455] = 8'h69;
        rom[456] = 8'h67;
        rom[457] = 8'h68;
        rom[458] = 8'h74; 
              V = 6'b100000; 
              
  end

  always @ (posedge clk)
    begin
          if(SW) begin
          i = 0;  
          ii = 0;
          count = 0;           
          epost = rom[i];   end          
          if ( rom[i] == 8'h0 )
              begin
              R0temp[i] = 6'b111111;
              R1temp[i] = 6'b111110;
              R2temp[i] = 6'b111100;
              R3temp[i] = 6'b111000;
              end 
                 
          else if ( rom[i] == 8'h61 )
              begin
              R0temp[i] =  ((R0temp[i-1] << 1) | D_a);
              R1temp[i] = ((R1temp[i-1] << 1) | D_a) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
              R2temp[i] = ((R2temp[i-1] << 1) | D_a) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
              R3temp[i] = ((R3temp[i-1] << 1) | D_a) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
              end
              
          else if ( rom[i] == 8'h62 )
              begin 
              R0temp[i] =  ((R0temp[i-1] << 1) | D_b);
              R1temp[i] = ((R1temp[i-1] << 1) | D_b) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
              R2temp[i] = ((R2temp[i-1] << 1) | D_b) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
              R3temp[i] = ((R3temp[i-1] << 1) | D_b) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
              end
                  
           else if ( rom[i] == 8'h63 )
              begin
              R0temp[i] =  ((R0temp[i-1] << 1) | D_c);
              R1temp[i] = ((R1temp[i-1] << 1) | D_c) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
              R2temp[i] = ((R2temp[i-1] << 1) | D_c) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
              R3temp[i] = ((R3temp[i-1] << 1) | D_c) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;                 
              end
                
           else if ( rom[i] == 8'h64 )
              begin
              R0temp[i] =  ((R0temp[i-1] << 1) | D_d);
              R1temp[i] = ((R1temp[i-1] << 1) | D_d) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
              R2temp[i] = ((R2temp[i-1] << 1) | D_d) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
              R3temp[i] = ((R3temp[i-1] << 1) | D_d) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
              end
              
           else if ( rom[i] == 8'h65 )
             begin
             R0temp[i] =  ((R0temp[i-1] << 1) | D_e);
             R1temp[i] = ((R1temp[i-1] << 1) | D_e) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
             R2temp[i] = ((R2temp[i-1] << 1) | D_e) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
             R3temp[i] = ((R3temp[i-1] << 1) | D_e) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
             end
      else if ( rom[i] == 8'h66 )
             begin
             R0temp[i] =  ((R0temp[i-1] << 1) | D_f);
             R1temp[i] = ((R1temp[i-1] << 1) | D_f) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
             R2temp[i] = ((R2temp[i-1] << 1) | D_f) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
             R3temp[i] = ((R3temp[i-1] << 1) | D_f) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
             end
             
         else if ( rom[i] == 8'h67 )
             begin 
             R0temp[i] =  ((R0temp[i-1] << 1) | D_g);
             R1temp[i] = ((R1temp[i-1] << 1) | D_g) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
             R2temp[i] = ((R2temp[i-1] << 1) | D_g) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
             R3temp[i] = ((R3temp[i-1] << 1) | D_g) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
             end
                 
          else if ( rom[i] == 8'h68 )
             begin
             R0temp[i] =  (R0temp[i-1] << 1) | D_h;
             R1temp[i] = ((R1temp[i-1] << 1) | D_h) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
             R2temp[i] = ((R2temp[i-1] << 1) | D_h) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
             R3temp[i] = ((R3temp[i-1] << 1) | D_h) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;                 
             end
               
          else if ( rom[i] == 8'h69 )
             begin
             R0temp[i] =  ((R0temp[i-1] << 1) | D_i);
             R1temp[i] = ((R1temp[i-1] << 1) | D_i) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
             R2temp[i] = ((R2temp[i-1] << 1) | D_i) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
             R3temp[i] = ((R3temp[i-1] << 1) | D_i) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
             end
             
          else if ( rom[i] == 8'h6a )
            begin
            R0temp[i] =  ((R0temp[i-1] << 1) | D_j);
            R1temp[i] = ((R1temp[i-1] << 1) | D_j) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
            R2temp[i] = ((R2temp[i-1] << 1) | D_j) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
            R3temp[i] = ((R3temp[i-1] << 1) | D_j) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
            end
      else if ( rom[i] == 8'h6b )
            begin
            R0temp[i] =  ((R0temp[i-1] << 1) | D_k);
            R1temp[i] = ((R1temp[i-1] << 1) | D_k) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
            R2temp[i] = ((R2temp[i-1] << 1) | D_k) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
            R3temp[i] = ((R3temp[i-1] << 1) | D_k) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
            end
            
        else if ( rom[i] == 8'h6c )
            begin 
            R0temp[i] =  ((R0temp[i-1] << 1) | D_l);
            R1temp[i] = ((R1temp[i-1] << 1) | D_l) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
            R2temp[i] = ((R2temp[i-1] << 1) | D_l) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
            R3temp[i] = ((R3temp[i-1] << 1) | D_l) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
            end
                
         else if ( rom[i] == 8'h6d )
            begin
            R0temp[i] =  ((R0temp[i-1] << 1) | D_m);
            R1temp[i] = ((R1temp[i-1] << 1) | D_m) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
            R2temp[i] = ((R2temp[i-1] << 1) | D_m) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
            R3temp[i] = ((R3temp[i-1] << 1) | D_m) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;                 
            end
              
         else if ( rom[i] == 8'h6e )
            begin
            R0temp[i] =  ((R0temp[i-1] << 1) | D_n);
            R1temp[i] = ((R1temp[i-1] << 1) | D_n) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
            R2temp[i] = ((R2temp[i-1] << 1) | D_n) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
            R3temp[i] = ((R3temp[i-1] << 1) | D_n) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
            end
            
         else if ( rom[i] == 8'h6f )
           begin
           R0temp[i] =  ((R0temp[i-1] << 1) | D_o);
           R1temp[i] = ((R1temp[i-1] << 1) | D_o) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
           R2temp[i] = ((R2temp[i-1] << 1) | D_o) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
           R3temp[i] = ((R3temp[i-1] << 1) | D_o) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
           end
       else if ( rom[i] == 8'h70 )
           begin
           R0temp[i] =  ((R0temp[i-1] << 1) | D_p);
           R1temp[i] = ((R1temp[i-1] << 1) | D_p) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
           R2temp[i] = ((R2temp[i-1] << 1) | D_p) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
           R3temp[i] = ((R3temp[i-1] << 1) | D_p) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
           end
           
       else if ( rom[i] == 8'h71 )
           begin 
           R0temp[i] =  ((R0temp[i-1] << 1) | D_q);
           R1temp[i] = ((R1temp[i-1] << 1) | D_q) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
           R2temp[i] = ((R2temp[i-1] << 1) | D_q) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
           R3temp[i] = ((R3temp[i-1] << 1) | D_q) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
           end
               
        else if ( rom[i] == 8'h72 )
           begin
           R0temp[i] =  ((R0temp[i-1] << 1) | D_r);
           R1temp[i] = ((R1temp[i-1] << 1) | D_r) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
           R2temp[i] = ((R2temp[i-1] << 1) | D_r) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
           R3temp[i] = ((R3temp[i-1] << 1) | D_r) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;                 
           end
             
        else if ( rom[i] == 8'h73 )
           begin
           R0temp[i] = ( (R0temp[i-1] << 1) | D_s);
           R1temp[i] = ((R1temp[i-1] << 1) | D_s) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
           R2temp[i] = ((R2temp[i-1] << 1) | D_s) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
           R3temp[i] = ((R3temp[i-1] << 1) | D_s) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
           end
           
        else if ( rom[i] == 8'h74 )
          begin
          R0temp[i] =  ((R0temp[i-1] << 1) | D_t);
          R1temp[i] = ((R1temp[i-1] << 1) | D_t) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
          R2temp[i] = ((R2temp[i-1] << 1) | D_t) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
          R3temp[i] = ((R3temp[i-1] << 1) | D_t) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
          end
       else if ( rom[i] == 8'h75 )
          begin
          R0temp[i] =  ((R0temp[i-1] << 1) | D_u);
          R1temp[i] = ((R1temp[i-1] << 1) | D_u) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
          R2temp[i] = ((R2temp[i-1] << 1) | D_u) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
          R3temp[i] = ((R3temp[i-1] << 1) | D_u) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
          end
          
      else if ( rom[i] == 8'h76 )
          begin 
          R0temp[i] =  ((R0temp[i-1] << 1) | D_v);
          R1temp[i] = ((R1temp[i-1] << 1) | D_v) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
          R2temp[i] = ((R2temp[i-1] << 1) | D_v) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
          R3temp[i] = ((R3temp[i-1] << 1) | D_v) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
          end
              
       else if ( rom[i] == 8'h77 )
          begin
          R0temp[i] =  ((R0temp[i-1] << 1) | D_w);
          R1temp[i] = ((R1temp[i-1] << 1) | D_w) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
          R2temp[i] = ((R2temp[i-1] << 1) | D_w) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
          R3temp[i] = ((R3temp[i-1] << 1) | D_w) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;                 
          end
            
       else if ( rom[i] == 8'h78 )
          begin
          R0temp[i] =  ((R0temp[i-1] << 1) | D_x);
          R1temp[i] = ((R1temp[i-1] << 1) | D_x) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
          R2temp[i] = ((R2temp[i-1] << 1) | D_x) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
          R3temp[i] = ((R3temp[i-1] << 1) | D_x) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
          end
          
       else if ( rom[i] == 8'h79 )
         begin
         R0temp[i] =  ((R0temp[i-1] << 1) | D_y);
         R1temp[i] = ((R1temp[i-1] << 1) | D_y) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
         R2temp[i] = ((R2temp[i-1] << 1) | D_y) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
         R3temp[i] = ((R3temp[i-1] << 1) | D_y) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
         end
  else if ( rom[i] == 8'h7a )
         begin
         R0temp[i] =  ((R0temp[i-1] << 1) | D_z);
         R1temp[i] = ((R1temp[i-1] << 1) | D_z) & ((R0temp[i-1] & R0temp[i]) << 1) & (R0temp[i-1] | V) ;
         R2temp[i] = ((R2temp[i-1] << 1) | D_z) & ((R1temp[i-1] & R1temp[i]) << 1) & (R1temp[i-1] | V) ; 
         R3temp[i] = ((R3temp[i-1] << 1) | D_z) & ((R2temp[i-1] & R2temp[i]) << 1) & (R2temp[i-1] | V) ;              
         end
                  
        R0 = R0temp[i]; 
        R1 = R1temp[i];
        R2 = R2temp[i];
        R3 = R3temp[i];    
        
        if(R1temp[i][5] == 0) begin
            count = count + 1; end
        if(i == 458) begin counter = count; end

        i = i +1;   
     
     end

always @(*)
   case(counter)
  4'b0000 : LED = 16'b0000000000000001;
  4'b0001 : LED = 16'b0000000000000011;
  4'b0010 : LED = 16'b0000000000000111;  
  4'b0011 : LED = 16'b0000000000001111;
  4'b0100 : LED = 16'b0000000000011111;
  4'b0101 : LED = 16'b0000000000111111; 
  4'b0110 : LED = 16'b0000000001111111; 
  4'b0111 : LED = 16'b0000000011111111;  
  4'b1000 : LED = 16'b0000000111111111;  
  4'b1001 : LED = 16'b0000001111111111; 
  4'b1010 : LED = 16'b0000011111111111;
  default : LED = 16'b0000000000000000;
    endcase
endmodule



